Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.web.servlet.view
Class RedirectView

    java.lang.Object
      org.springframework.context.support.ApplicationObjectSupport
          org.springframework.web.context.support.WebApplicationObjectSupport
              org.springframework.web.servlet.view.AbstractView
                  org.springframework.web.servlet.view.AbstractUrlBasedView
                      org.springframework.web.servlet.view.RedirectView

All Implemented Interfaces:
  Aware, BeanNameAware, InitializingBean, ApplicationContextAware, ServletContextAware, SmartView, View

    public class RedirectView

extends AbstractUrlBasedView
implements SmartView

View that redirects to an absolute, context relative, or current request relative URL. The URL may be a URI template in which case the URI template variables will be replaced with values available in the model. By default all primitive model attributes (or collections thereof) are exposed as HTTP query parameters (assuming they've not been used as URI template variables), but this behavior can be changed by overriding the `isEligibleProperty(String, Object)` method.

A URL for this view is supposed to be a HTTP redirect URL, i.e. suitable for HttpServletResponse's `sendRedirect` method, which is what actually does the redirect if the HTTP 1.0 flag is on, or via sending back an HTTP 303 code - if the HTTP 1.0 compatibility flag is off.

Note that while the default value for the "contextRelative" flag is off, you will probably want to almost always set it to true. With the flag off, URLs starting with "/" are considered relative to the web server root, while with the flag on, they are considered relative to the web application root. Since most web applications will never know or care what their context path actually is, they are much better off setting this flag to true, and submitting paths which are to be considered relative to the web application root.

NOTE when using this redirect view in a Portlet environment: Make sure that your controller respects the Portlet `sendRedirect` constraints. When e.g. using `SimpleFormController`, make sure to set your controller's `"redirectAction"` property to "true", in order to make the controller base class behave accordingly.

Author:
  Rod Johnson, Juergen Hoeller, Colin Sampaleanu, Sam Brannen, Arjen Poutsma, Rossen Stoyanchev
See Also:
  `setContextRelative(boolean)`, `setHttp10Compatible(boolean)`, `setExposeModelAttributes(boolean)`, `HttpServletResponse.sendRedirect(java.lang.String)`

Field Summary

Fields inherited from class org.springframework.web.servlet.view.AbstractView
`DEFAULT_CONTENT_TYPE`

Fields inherited from class org.springframework.context.support.ApplicationObjectSupport
`logger`

Fields inherited from interface org.springframework.web.servlet.View
`PATH_VARIABLES, RESPONSE_STATUS_ATTRIBUTE`

Constructor Summary
`RedirectView()` Constructor for use as a bean.
`RedirectView(String url)` Create a new RedirectView with the given URL.
`RedirectView(String url, boolean contextRelative)` Create a new RedirectView with the given URL.
`RedirectView(String url, boolean contextRelative, boolean http10Compatible)` Create a new RedirectView with the given URL.
`RedirectView(String url, boolean contextRelative, boolean http10Compatible, boolean exposeModelAttributes)` Create a new RedirectView with the given URL.

Method Summary
`protected void` | `appendQueryProperties(StringBuilder targetUrl, Map<String,Object> model, String encodingScheme)` Append query properties to the redirect URL.
`protected String` | `createTargetUrl(Map<String,Object> model, HttpServletRequest request)` Creates the target URL by checking if the redirect string is a URI template first, expanding it with the given model, and then optionally appending simple type model attributes as query String parameters.
`protected HttpStatus` | `getHttp11StatusCode(HttpServletRequest request, HttpServletResponse response, String targetUrl)` Determines the status code to use for HTTP 1.1 compatible requests.
`protected boolean` | `isContextRequired()` An ApplicationContext is not strictly required for RedirectView.
`protected boolean` | `isEligibleProperty(String key, Object value)` Determine whether the given model element should be exposed as a query property.
`protected boolean` | `isEligibleValue(Object value)` Determine whether the given model element value is eligible for exposure.
`boolean` | `isRedirectView()` Returns "true" indicating this view performs a redirect.
`protected Map<String,Object>` | `queryProperties(Map<String,Object> model)` Determine name-value pairs for query strings, which will be stringified, URL-encoded and formatted by `appendQueryProperties(java.lang.StringBuilder, java.util.Map, java.lang.String)`.
`protected void` | `renderMergedOutputModel(Map<String,Object> model, HttpServletRequest request, HttpServletResponse response)` Convert model to request parameters and redirect to the given URL.
`protected StringBuilder` | `replaceUriTemplateVariables(String targetUrl, Map<String,Object> model, Map<String,String> currentUriVariables, String encodingScheme)` Replace URI template variables in the target URL with encoded model attributes or URI variables from the current request.
`protected void` | `sendRedirect(HttpServletRequest request, HttpServletResponse response, String targetUrl, boolean http10Compatible)` Send a redirect back to the HTTP client
`void` | `setContextRelative(boolean contextRelative)` Set whether to interpret a given URL that starts with a slash ("/") as relative to the current ServletContext, i.e.
`void` | `setEncodingScheme(String encodingScheme)` Set the encoding scheme for this view.
`void` | `setExpandUriTemplateVariables(boolean expandUriTemplateVariables)` Whether to treat the redirect URL as a URI template.
`void` | `setExposeModelAttributes(boolean exposeModelAttributes)` Set the `exposeModelAttributes` flag which denotes whether or not model attributes should be exposed as HTTP query parameters.
`void` | `setHttp10Compatible(boolean http10Compatible)` Set whether to stay compatible with HTTP 1.0 clients.
`void` | `setStatusCode(HttpStatus statusCode)` Set the status code for this view.
`protected String` | `updateTargetUrl(String targetUrl, Map<String,Object> model, HttpServletRequest request, HttpServletResponse response)` Find the registered `RequestDataValueProcessor`, if any, and allow it to update the redirect target URL.
`protected String` | `urlEncode(String input, String encodingScheme)` URL-encode the given input String with the given encoding scheme.

Methods inherited from class org.springframework.web.servlet.view.AbstractUrlBasedView
`afterPropertiesSet, checkResource, getUrl, isUrlRequired, setUrl, toString`

Methods inherited from class org.springframework.web.servlet.view.AbstractView
`addStaticAttribute, createMergedOutputModel, createRequestContext, createTemporaryOutputStream, exposeModelAsRequestAttributes, generatesDownloadContent, getAttributesMap, getBeanName, getContentType, getRequestContextAttribute, getStaticAttributes, isExposePathVariables, prepareResponse, render, setAttributes, setAttributesCSV, setAttributesMap, setBeanName, setContentType, setExposePathVariables, setRequestContextAttribute, writeToResponse`

Methods inherited from class org.springframework.web.context.support.WebApplicationObjectSupport
`getServletContext, getTempDir, getWebApplicationContext, initApplicationContext, initServletContext, setServletContext`

Methods inherited from class org.springframework.context.support.ApplicationObjectSupport
`getApplicationContext, getMessageSourceAccessor, initApplicationContext, requiredContextClass, setApplicationContext`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.springframework.web.servlet.View
`getContentType, render`

Constructor Detail

### RedirectView

    public RedirectView()

  Constructor for use as a bean.

### RedirectView

    public RedirectView(String url)

  Create a new RedirectView with the given URL.

  The given URL will be considered as relative to the web server, not as relative to the current ServletContext.

  Parameters:
    `url` - the URL to redirect to
  See Also:
    `RedirectView(String, boolean)`

### RedirectView

    public RedirectView(String url,
                        boolean contextRelative)

  Create a new RedirectView with the given URL.

  Parameters:
    `url` - the URL to redirect to
    `contextRelative` - whether to interpret the given URL as relative to the current ServletContext

### RedirectView

    public RedirectView(String url,
                        boolean contextRelative,
                        boolean http10Compatible)

  Create a new RedirectView with the given URL.

  Parameters:
    `url` - the URL to redirect to
    `contextRelative` - whether to interpret the given URL as relative to the current ServletContext
    `http10Compatible` - whether to stay compatible with HTTP 1.0 clients

### RedirectView

    public RedirectView(String url,
                        boolean contextRelative,
                        boolean http10Compatible,
                        boolean exposeModelAttributes)

  Create a new RedirectView with the given URL.

  Parameters:
    `url` - the URL to redirect to
    `contextRelative` - whether to interpret the given URL as relative to the current ServletContext
    `http10Compatible` - whether to stay compatible with HTTP 1.0 clients
    `exposeModelAttributes` - whether or not model attributes should be exposed as query parameters

Method Detail

### setContextRelative

    public void setContextRelative(boolean contextRelative)

  Set whether to interpret a given URL that starts with a slash ("/") as relative to the current ServletContext, i.e. as relative to the web application root.

  Default is "false": A URL that starts with a slash will be interpreted as absolute, i.e. taken as-is. If "true", the context path will be prepended to the URL in such a case.

  See Also:
    `HttpServletRequest.getContextPath()`

### setHttp10Compatible

    public void setHttp10Compatible(boolean http10Compatible)

  Set whether to stay compatible with HTTP 1.0 clients.

  In the default implementation, this will enforce HTTP status code 302 in any case, i.e. delegate to `HttpServletResponse.sendRedirect`. Turning this off will send HTTP status code 303, which is the correct code for HTTP 1.1 clients, but not understood by HTTP 1.0 clients.

  Many HTTP 1.1 clients treat 302 just like 303, not making any difference. However, some clients depend on 303 when redirecting after a POST request; turn this flag off in such a scenario.

  See Also:
    `HttpServletResponse.sendRedirect(java.lang.String)`

### setExposeModelAttributes

    public void setExposeModelAttributes(boolean exposeModelAttributes)

  Set the `exposeModelAttributes` flag which denotes whether or not model attributes should be exposed as HTTP query parameters.

  Defaults to `true`.

### setEncodingScheme

    public void setEncodingScheme(String encodingScheme)

  Set the encoding scheme for this view.

  Default is the request's encoding scheme (which is ISO-8859-1 if not specified otherwise).

### setStatusCode

    public void setStatusCode(HttpStatus statusCode)

  Set the status code for this view.

  Default is to send 302/303, depending on the value of the `http10Compatible` flag.

### setExpandUriTemplateVariables

    public void setExpandUriTemplateVariables(boolean expandUriTemplateVariables)

  Whether to treat the redirect URL as a URI template. Set this flag to `false` if the redirect URL contains open and close curly braces "{", "}" and you don't want them interpreted as URI variables.

  Defaults to `true`.

  Parameters:
    `expandUriTemplateVariables` -

### isRedirectView

    public boolean isRedirectView()

  Returns "true" indicating this view performs a redirect.

  Specified by:
    `isRedirectView` in interface `SmartView`

### isContextRequired

    protected boolean isContextRequired()

  An ApplicationContext is not strictly required for RedirectView.

  Overrides:
    `isContextRequired` in class `WebApplicationObjectSupport`
  See Also:
    `ApplicationObjectSupport.getApplicationContext()`, `ApplicationObjectSupport.getMessageSourceAccessor()`, `WebApplicationObjectSupport.getWebApplicationContext()`, `WebApplicationObjectSupport.getServletContext()`, `WebApplicationObjectSupport.getTempDir()`

### renderMergedOutputModel

    protected void renderMergedOutputModel(Map<String,Object> model,
                                           HttpServletRequest request,
                                           HttpServletResponse response)
                                    throws IOException

  Convert model to request parameters and redirect to the given URL.

  Specified by:
    `renderMergedOutputModel` in class `AbstractView`
  Parameters:
    `model` - combined output Map (never `null`), with dynamic values taking precedence over static attributes
    `request` - current HTTP request
    `response` - current HTTP response
  Throws:
    `IOException`
  See Also:
    `appendQueryProperties(java.lang.StringBuilder, java.util.Map, java.lang.String)`, `sendRedirect(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse, java.lang.String, boolean)`

### createTargetUrl

    protected final String createTargetUrl(Map<String,Object> model,
                                           HttpServletRequest request)
                                    throws UnsupportedEncodingException

  Creates the target URL by checking if the redirect string is a URI template first, expanding it with the given model, and then optionally appending simple type model attributes as query String parameters.

  Throws:
    `UnsupportedEncodingException`

### replaceUriTemplateVariables

    protected StringBuilder replaceUriTemplateVariables(String targetUrl,
                                                        Map<String,Object> model,
                                                        Map<String,String> currentUriVariables,
                                                        String encodingScheme)
                                                 throws UnsupportedEncodingException

  Replace URI template variables in the target URL with encoded model attributes or URI variables from the current request. Model attributes referenced in the URL are removed from the model.

  Parameters:
    `targetUrl` - the redirect URL
    `model` - Map that contains model attributes
    `currentUriVariables` - current request URI variables to use
    `encodingScheme` - the encoding scheme to use
  Throws:
    `UnsupportedEncodingException` - if string encoding failed

### appendQueryProperties

    protected void appendQueryProperties(StringBuilder targetUrl,
                                         Map<String,Object> model,
                                         String encodingScheme)
                                  throws UnsupportedEncodingException

  Append query properties to the redirect URL. Stringifies, URL-encodes and formats model attributes as query properties.

  Parameters:
    `targetUrl` - the StringBuilder to append the properties to
    `model` - Map that contains model attributes
    `encodingScheme` - the encoding scheme to use
  Throws:
    `UnsupportedEncodingException` - if string encoding failed
  See Also:
    `queryProperties(java.util.Map)`

### queryProperties

    protected Map<String,Object> queryProperties(Map<String,Object> model)

  Determine name-value pairs for query strings, which will be stringified, URL-encoded and formatted by `appendQueryProperties(java.lang.StringBuilder, java.util.Map, java.lang.String)`.

  This implementation filters the model through checking `isEligibleProperty(String, Object)` for each element, by default accepting Strings, primitives and primitive wrappers only.

  Parameters:
    `model` - the original model Map
  Returns:
    the filtered Map of eligible query properties
  See Also:
    `isEligibleProperty(String, Object)`

### isEligibleProperty

    protected boolean isEligibleProperty(String key,
                                         Object value)

  Determine whether the given model element should be exposed as a query property.

  The default implementation considers Strings and primitives as eligible, and also arrays and Collections/Iterables with corresponding elements. This can be overridden in subclasses.

  Parameters:
    `key` - the key of the model element
    `value` - the value of the model element
  Returns:
    whether the element is eligible as query property

### isEligibleValue

    protected boolean isEligibleValue(Object value)

  Determine whether the given model element value is eligible for exposure.

  The default implementation considers primitives, Strings, Numbers, Dates, URIs, URLs and Locale objects as eligible. This can be overridden in subclasses.

  Parameters:
    `value` - the model element value
  Returns:
    whether the element value is eligible
  See Also:
    `BeanUtils.isSimpleValueType(java.lang.Class)`

### urlEncode

    protected String urlEncode(String input,
                               String encodingScheme)
                        throws UnsupportedEncodingException

  URL-encode the given input String with the given encoding scheme.

  The default implementation uses `URLEncoder.encode(input, enc)`.

  Parameters:
    `input` - the unencoded input String
    `encodingScheme` - the encoding scheme
  Returns:
    the encoded output String
  Throws:
    `UnsupportedEncodingException` - if thrown by the JDK URLEncoder
  See Also:
    `URLEncoder.encode(String, String)`, `URLEncoder.encode(String)`

### updateTargetUrl

    protected String updateTargetUrl(String targetUrl,
                                     Map<String,Object> model,
                                     HttpServletRequest request,
                                     HttpServletResponse response)

  Find the registered `RequestDataValueProcessor`, if any, and allow it to update the redirect target URL.

  Returns:
    the updated URL or the same as URL as the one passed in

### sendRedirect

    protected void sendRedirect(HttpServletRequest request,
                                HttpServletResponse response,
                                String targetUrl,
                                boolean http10Compatible)
                         throws IOException

  Send a redirect back to the HTTP client

  Parameters:
    `request` - current HTTP request (allows for reacting to request method)
    `response` - current HTTP response (for sending response headers)
    `targetUrl` - the target URL to redirect to
    `http10Compatible` - whether to stay compatible with HTTP 1.0 clients
  Throws:
    `IOException` - if thrown by response methods

### getHttp11StatusCode

    protected HttpStatus getHttp11StatusCode(HttpServletRequest request,
                                             HttpServletResponse response,
                                             String targetUrl)

  Determines the status code to use for HTTP 1.1 compatible requests.

  The default implementation returns the `statusCode` property if set, or the value of the `View.RESPONSE_STATUS_ATTRIBUTE` attribute. If neither are set, it defaults to `HttpStatus.SEE_OTHER` (303).

  Parameters:
    `request` - the request to inspect
    `response` - the servlet response
    `targetUrl` - the target URL
  Returns:
    the response status

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD